#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
# -----------------------------------------------------------------------------------------------
# THIS PLUGIN WAS DEVELOPED AND TESTED UNDER WINDOWS VISTA ONLY AND MAY OR MAY NOT WORK ON A MAC. 
# -----------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
# -----------------------------------------------------------------------------------------------
#    Name:	Select by Radius
#      By:	sdmitch
#   Usage:	Select all Construction Points within a given distance of selected Construction Point.
#		 Note:	
#			
#    Date:	Jul 2012
#------------------------------------------------------------------------------------------------
#
require 'Sketchup'
#
if not file_loaded?(File.basename(__FILE__))
    UI.menu('Plugins').add_item('Selection By Radius') {Selection_By_Radius.main }
	 file_loaded(File.basename(__FILE__))
end
#
module Selection_By_Radius
	def self.main
		mod = Sketchup.active_model
		ent = mod.active_entities
		sel = mod.selection
		unless sel.empty?
			if sel.first.is_a?(Sketchup::ConstructionPoint)
				ctr=sel.first.position
				@r1 = 0.0.feet unless @r1; @r2 = 2.0.feet unless @r2
				inp = inputbox([" Inner Radius:","Outter Radius:"],[@r1,@r2],"Selection by Radius")
				if inp
					@r1 = inp[0]; @r2 = inp[1]
					unless @r1 >= @r2
						ent.each{|e|
							if e.is_a?(Sketchup::ConstructionPoint)
								r=ctr.distance e.position
								if r > @r1 && r < @r2
									sel.add e
								end
							end
						}
					else
						UI.messagebox "Inner Radius is greater than or equal to Outter Radius"
					end
				end
			else
				UI.messagebox "Select a single Construction Point"
			end
		else
			UI.messagebox "Select a single Construction Point and rerun Plugin"
		end
	end
end
